//
//	CEntry
//

#pragma once

#include "CString.h"

class istream;
class ostream;

class CEntry : public LModelObject
{
public:
	enum {
		kModelID = 'ENTR'
	};

	enum {
		kFieldCount = 4,
		kMaximumFieldLength = 255
	};

	CEntry(LModelObject * inSuperModel = nil);
	CEntry(const CEntry &);
	CEntry & operator = (const CEntry &);
	~CEntry();
	
	const CString & GetField(UInt16) const;
	void SetField(UInt16, const CString &);

	virtual void 	GetAEProperty(DescType inProperty, const AEDesc & inRequestedType,
						AEDesc & outPropertyDesc) const;
	virtual void	SetAEProperty(DescType inProperty, const AEDesc & inValue,
						AEDesc & outAEReply);
	virtual void	GetImportantAEProperties(AERecord & outRecord);
	virtual void	GetDifferentAEProperties(const CEntry & inCompare, AERecord & outRecord) const;
	virtual const StringPtr GetModelNamePtr() const;

	virtual void  HandleDelete(AppleEvent & outAEReply, AEDesc & outResult);
		// Handles the delete method by telling the document to delete this object.
	
private:
	static const char kFieldSeparator;	// = '\t'
	static const char kEntrySeparator;	// = '\n'
	
	static const DescType kFieldProperties[kFieldCount];
	
	CString	mField[kFieldCount];

	friend ostream & operator << (ostream & stream, CEntry const & rec);
	friend istream & operator >> (istream & stream, CEntry & rec);
};

extern const CEntry sEmptyEntry;
