//
//	CLookupWindow
//

#if !REZ

#pragma once

#include <LWindow.h>

class CEntry;
class CLookupDocument;
class CEntryList;

class CLookupWindow : public LWindow, public LListener
{
public:
	static void		Register();

	virtual void	ListenToMessage(MessageT inMessage, void *);

private:

	enum {
		kClassID = 'LWIN'
	};
	static CLookupWindow * CreateFromStream(LStream *inStream);

	CEntryList *		mList;
	CLookupDocument *	mDocument;
	LEditField *		mField1;
	LEditField *		mField2;
	LEditField *		mField3;
	LEditField *		mField4;
	LControl *			mChangeButton;
	
	CLookupWindow(LStream *inStream);

	virtual void	FinishCreateSelf();
	
	void SetFieldData(const CEntry & record);
	void GetFieldData(CEntry &);
};

#endif

#define kListID			'LIST'
#define kScrollerID		'SCRL'
#define kField1ID		'NAME'
#define kField2ID		'PHN1'
#define kField3ID		'PHN2'
#define kField4ID		'MAIL'
#define kNewButtonID	'NEWb'
#define kChangeButtonID	'CHGb'
